#include "slam_manager.h"

namespace slam
{

void SlamManager::Init()
{
     DataManager::getInstance().Init();
     pack_line_ptr = std::make_shared<PackageLine>();
     pack_line_ptr->Init();
}

void SlamManager::InputImuData2Slam(slam::ImuData _imu)
{
    DataManager::getInstance().InputImuMsg(&_imu);
}

void SlamManager::InputGnssData2Slam(slam::GnssData _gnss)
{
    DataManager::getInstance().InputGnssMsg(&_gnss);
}
void SlamManager::InputInsData2Slam(slam::InsData _ins)
{
    DataManager::getInstance().InputInsMsg(&_ins);

    slam::InsData wk_ins;
    bool wk_ins_ret_flag = DataManager::getInstance().GetInsMsg(&wk_ins);

    if(wk_ins_ret_flag)
    {
        pack_line_ptr->SetHostVehiclePosition(wk_ins);
    }

}
void SlamManager::InputVehicleData2Slam(slam::VehicleData _can)
{
    DataManager::getInstance().InputCanMsg(&_can);
}
void SlamManager::InputVisionData2Slam(slam::RoadFrame _cam)
{
    DataManager::getInstance().InputVisionMsg(&_cam);
}

bool SlamManager::GetDecisionResultBySlam(slam::ControlWaypoints* _cyp)
{
    return DataManager::getInstance().GetDecisionResult(_cyp);
}

bool SlamManager::GetOdomResultBySlam(slam::slam_odometry* _odom)
{
    return DataManager::getInstance().GetOdometryResult(_odom);
}

bool GetRMResultBySlam(slam::slam_road_model* _rm)
{
    return DataManager::getInstance().GetRoadModelResult(_rm);
}
}
